package com.platform.controller;

import com.platform.annotation.CanUserUpdateRecord;
import com.platform.entity.AdEntity;
import com.platform.entity.Result;
import com.platform.service.AdService;
import com.platform.utils.PageUtils;
import com.platform.utils.PageUtilsPlus;
import com.platform.utils.Query;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * Controller
 *
 * @author lipengjun
 * @email 939961241@qq.com
 * @date 2017-08-19 09:37:35
 */
@RestController
@RequestMapping("ad")
public class AdController {
    @Autowired
    private AdService adService;

    /**
     * 查看列表
     */
    @RequestMapping("/list")

    public Result list(@RequestBody Map<String, Object> params) {
        //查询列表数据
        Query query = new Query(params);

        List<AdEntity> adList = adService.queryList(query);
        int total = adService.queryTotal(query);

        PageUtils pageUtil = new PageUtils(adList, total, query.getLimit(), query.getPage());

        return Result.success(PageUtilsPlus.page(adList,(long) total,(long) query.getLimit(),(long) query.getPage()));
    }


    /**
     * 查看信息
     */
    @RequestMapping("/info/{id}")

    public Result info(@PathVariable("id") Integer id) {
        AdEntity ad = adService.queryObject(id);

        return Result.success( ad);
    }

    /**
     * 保存
     */
    @CanUserUpdateRecord
    @RequestMapping("/save")

    public Result save(@RequestBody AdEntity ad) {
        adService.save(ad);

        return Result.success();
    }

    /**
     * 修改
     */
    @CanUserUpdateRecord
    @RequestMapping("/update")

    public Result update(@RequestBody AdEntity ad) {
        adService.update(ad);

        return Result.success();
    }

    /**
     * 删除
     */
    @CanUserUpdateRecord
    @RequestMapping("/delete")

    public Result delete(@RequestBody Integer[] ids) {
        adService.deleteBatch(ids);

        return Result.success();
    }

    /**
     * 查看所有列表
     */
    @RequestMapping("/queryAll")
    public Result queryAll(@RequestBody Map<String, Object> params) {

        List<AdEntity> list = adService.queryList(params);

        return Result.success( list);
    }
}
